package repository

import (
	"actatempus_backend/internal/domain/entities"
	"context"

	E "github.com/IBM/fp-go/either"
)

// ProjectRepository defines the operations for interacting with project data.
type ProjectRepository interface {
	Create(ctx context.Context) func(project entities.ProjectCreate) E.Either[error, entities.Project]
	FindByID(ctx context.Context) func(id string) E.Either[error, entities.Project]
	FindByUserID(ctx context.Context) func(userID string) E.Either[error, []entities.Project]
	Update(ctx context.Context) func(project entities.ProjectUpdate) E.Either[error, entities.Project]
	Delete(ctx context.Context) func(id string) E.Either[error, entities.Project]
	FindAll(ctx context.Context) E.Either[error, []entities.Project]
}

